﻿Public Class cdNettroFeatureLayer2

  Public Function getMapImage(ByVal minX As Double, ByVal maxY As Double, ByVal maxX As Double, ByVal minY As Double, _
                           ByVal Width As Single, ByVal Height As Single) As Byte()

    Const CACHE_ID As String = "NettroFeatureLayer2"

    Dim BoundingBox As ThinkGeo.MapSuite.Core.RectangleShape
    Dim bitmapCache As ThinkGeo.MapSuite.Core.FileBitmapTileCache
    Dim Scale As Double
    Dim ms As System.IO.MemoryStream
    Dim matrix As ThinkGeo.MapSuite.Core.MapSuiteTileMatrix
    Dim bmp As System.Drawing.Bitmap

    Dim oCanvas As ThinkGeo.MapSuite.Core.GdiPlusGeoCanvas
    Dim oImage As ThinkGeo.MapSuite.Core.GeoImage
    Dim oLabelsInAllLayers As System.Collections.ObjectModel.Collection(Of ThinkGeo.MapSuite.Core.SimpleCandidate)
    Dim oShapeFileFeatureLayer As ThinkGeo.MapSuite.Core.ShapeFileFeatureLayer
    Dim strShapeFile = System.IO.Path.Combine(System.Environment.CurrentDirectory, "alk-flurstueck-objekt.shp")
    Dim oOverlay As ThinkGeo.MapSuite.DesktopEdition.LayerOverlay

    BoundingBox = ThinkGeo.MapSuite.Core.ExtentHelper.SnapToZoomLevel(New ThinkGeo.MapSuite.Core.RectangleShape(minX, maxY, maxX, minY), ThinkGeo.MapSuite.Core.GeographyUnit.Meter, _
                                                              Width, Height, New ThinkGeo.MapSuite.Core.ZoomLevelSet())

    Scale = ThinkGeo.MapSuite.Core.ExtentHelper.GetScale(BoundingBox, Width, ThinkGeo.MapSuite.Core.GeographyUnit.Meter)

    ms = New System.IO.MemoryStream
    matrix = New ThinkGeo.MapSuite.Core.MapSuiteTileMatrix(Scale, 256, 256, ThinkGeo.MapSuite.Core.GeographyUnit.Meter)

    bitmapCache = New ThinkGeo.MapSuite.Core.FileBitmapTileCache(System.IO.Path.Combine(System.Environment.CurrentDirectory, "ServerCache"), _
                                                            CACHE_ID, ThinkGeo.MapSuite.Core.TileImageFormat.Png, matrix)


    oCanvas = New ThinkGeo.MapSuite.Core.GdiPlusGeoCanvas
    oLabelsInAllLayers = New System.Collections.ObjectModel.Collection(Of ThinkGeo.MapSuite.Core.SimpleCandidate)

    bmp = New System.Drawing.Bitmap(CInt(Width), CInt(Height))
    oImage = New ThinkGeo.MapSuite.Core.GeoImage(bmp.Width, bmp.Height)

    oOverlay = New ThinkGeo.MapSuite.DesktopEdition.LayerOverlay
    oOverlay.TileCache = bitmapCache
    oShapeFileFeatureLayer = New ThinkGeo.MapSuite.Core.ShapeFileFeatureLayer(strShapeFile)
    oShapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = ThinkGeo.MapSuite.Core.AreaStyles.County2
    oShapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.OutlinePen.Width = 4.0
    oShapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ThinkGeo.MapSuite.Core.ApplyUntilZoomLevel.Level20
    oOverlay.Layers.Add(oShapeFileFeatureLayer)

    oCanvas.BeginDrawing(oImage, BoundingBox, ThinkGeo.MapSuite.Core.GeographyUnit.Meter)
    oOverlay.Draw(oCanvas)

    If oCanvas.IsDrawing Then
      oCanvas.Flush()
      oCanvas.EndDrawing()
    End If

    ms = ThinkGeo.MapSuite.Core.GdiPlusGeoCanvas.ConvertGeoImageToMemoryStream(oImage, System.Drawing.Imaging.ImageFormat.Png)
    bmp = New System.Drawing.Bitmap(ms)

    'Write in the memorystream 
    bmp.Save(ms, System.Drawing.Imaging.ImageFormat.Png)
    bmp.Dispose()
    bmp = Nothing
    Return ms.ToArray

  End Function



End Class
